Minimap:SetMovable(true)
Minimap:SetUserPlaced(true)
local blank = "Interface\\Addons\\ncMinimap\\blank"
local objects = {}
local unlocked
local p = CreateFrame("Frame", mapborder, Minimap)
local function kill() end
local function out(msg) print("NCM: "..msg) end
local function createobject(num)
	local f = CreateFrame("Frame", "MinimapMovingObject"..num)
	f:SetBackdrop( { 
		bgFile = blank, 
		edgeFile = blank, 
		tile = false, tileSize = 0, edgeSize = 2,
		insets = { left = -.64, right = -.64, top = -.64, bottom = -.64 }
	})
	f:SetBackdropBorderColor(ncMinimap.r,ncMinimap.g,ncMinimap.b)
	f:SetBackdropColor(.1,.1,.1)
	
	if num/2==floor(num/2) then
		f:SetWidth(10)
		f:SetHeight(3)
	else
		f:SetWidth(3)
		f:SetHeight(10)
	end
	
	if num==1 then
		f.func = function(self)
			if self.method == 1 then
				self:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMLEFT", -3, self.elapsed+2)
			else
				self:SetPoint("TOPLEFT", Minimap, "TOPLEFT", -3, -self.elapsed-2)
			end
		end
	elseif num==2 then
		f.func = function(self)
			if self.method == 1 then
				self:SetPoint("TOPLEFT", Minimap, "TOPLEFT", self.elapsed+2, 3)
			else
				self:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", -self.elapsed-2, 3)
			end
		end
	elseif num==3 then
		f.func = function(self)
			if self.method == 1 then
				self:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", 4, -self.elapsed-2)
			else
				self:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", 4, self.elapsed+2)
			end
		end
	else
		f.func = function(self)
			if self.method == 1 then
				self:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", -self.elapsed-2, -4)
			else
				self:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMLEFT", self.elapsed+2, -4)
			end
		end
	end
	
	function f:SetMovingSpeed(spd)
		self.mult = spd
		self:Show()
	end
	
	f.speed = ncMinimap.speed
	f.combatspeed = ncMinimap.combatspeed
	f:SetFrameStrata("BACKGROUND")
	f:SetFrameLevel(1)	
	f:SetScale(ncMinimap.scale)
	f.elapsed = 0
	f.method = 1
	f.mult = f.speed
	f:SetScript("OnUpdate", function(self, elapsed)
		if self.mult==0 then self:Hide() return end
		self.elapsed = self.elapsed + floor(elapsed*self.mult*10000000)/10000000
		if self.elapsed > 120*UIParent:GetScale() then
			self.method = self.method + 1
			self.elapsed = 0
		end
		if self.method > 2 then
			self.method = 1
		end
		self:ClearAllPoints()
		f.func(self)
	end)
	f:RegisterEvent("PLAYER_REGEN_DISABLED")
	f:RegisterEvent("PLAYER_REGEN_ENABLED")
	f:SetScript("OnEvent", function(self, event)
		if event=="PLAYER_REGEN_DISABLED" then
			self:SetMovingSpeed(f.combatspeed)
		else
			self:SetMovingSpeed(f.speed)
		end
	end)
	objects[num] = f
end
local function init()
	if not ncMinimap then
		ncMinimap = {
			combatspeed = 80,
			speed = 20,
			scale = 1,
			r = .6,
			g = .6,
			b = .6,
		}
	end
	p:SetFrameLevel(1)
	p:SetFrameStrata("BACKGROUND")
	p:SetPoint("TOPLEFT")
	p:SetPoint("BOTTOMRIGHT")
	p:SetScale(1)
	p:SetBackdrop({ 
		bgFile = blank, 
		edgeFile = blank, 
		tile = false, tileSize = 0, edgeSize = 2, 
		insets = { left = -1, right = -1, top = -1, bottom = -1 }
	})
	p:SetBackdropColor(.1,.1,.1)
	p:SetBackdropBorderColor(ncMinimap.r,ncMinimap.g,ncMinimap.b)
	p:Show()
	Minimap:SetScale(ncMinimap.scale)
	Minimap:SetFrameStrata("BACKGROUND")
	Minimap:SetScript("OnDragStart", Minimap.StartMoving)
	Minimap:SetScript("OnDragStop", Minimap.StopMovingOrSizing)
	Minimap:SetMaskTexture("Interface\\AddOns\\ncMinimap\\mask")
	MinimapBorder:Hide()
	MinimapBorderTop:Hide()
	MinimapZoomIn:Hide()
	MinimapZoomOut:Hide()
	MiniMapVoiceChatFrame:Hide()
	MiniMapVoiceChatFrame:UnregisterAllEvents()
	MiniMapVoiceChatFrame.Show = kill
	GameTimeFrame:Hide()
	MinimapZoneTextButton:Hide()
	MinimapZoneTextButton:UnregisterAllEvents()
	MiniMapTracking:Hide()
	MiniMapTracking:UnregisterAllEvents()
	MiniMapMailBorder:Hide()
	MiniMapMailIcon:SetTexture("Interface\\AddOns\\ncMinimap\\mail")
	MiniMapMailIcon:ClearAllPoints()
	MiniMapMailIcon:SetPoint("BOTTOMLEFT", Minimap, 3, 0)
	MiniMapMailFrame:SetAllPoints(MiniMapMailIcon)
	MiniMapBattlefieldFrame:ClearAllPoints()
	MiniMapBattlefieldFrame:SetPoint("BOTTOMRIGHT", Minimap, 1, -1)
	MinimapNorthTag.Show = kill
	MinimapNorthTag:Hide()
	MiniMapWorldMapButton:Hide()
	MiniMapWorldMapButton:UnregisterAllEvents()
	MiniMapInstanceDifficulty:ClearAllPoints()
	MiniMapInstanceDifficulty:SetParent(Minimap)
	MiniMapInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)
	local function UpdateLFG()
		MiniMapLFGFrame:ClearAllPoints()
		MiniMapLFGFrame:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", 0, -3)
	end
	hooksecurefunc("MiniMapLFG_UpdateIsShown", UpdateLFG)
	Minimap:EnableMouseWheel(true)
	Minimap:SetScript("OnMouseWheel", function(self, d)
		if d > 0 then
			_G.MinimapZoomIn:Click()
		elseif d < 0 then
			_G.MinimapZoomOut:Click()
		end
	end)
	Minimap:SetScript("OnMouseUp", function(self, btn)
		if btn == "RightButton" then
			ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self)
		elseif btn == "MiddleButton" then
			GameTimeFrame:Click() 
		else
			Minimap_OnClick(self)
		end
	end)
	for i=1,4 do
		createobject(i)
	end
end

SLASH_NCMINIMAP1 = "/ncminimap"
SLASH_NCMINIMAP2 = "/ncm"
SlashCmdList.NCMINIMAP = function(msg)
	local arg1, arg2, arg3, arg4 = string.split(" ", string.lower(msg))
	if arg1=="speed" then
		spd = tonumber(arg2)
		if spd==0 or spd<0 then
			ncMinimap.speed = spd
			for i=1,#objects do
				objects[i]:Hide()
			end
			out("Moving objects out of combat hidden")
		else
			ncMinimap.speed = spd
			for i=1,#objects do				
				objects[i].mult = spd
				if not InCombatLockdown() then
					objects[i]:SetMovingSpeed(spd)
				end
			end
			out("Moving objects out of combat speed set to "..spd)
		end
	elseif arg1=="combatspeed" then
		spd = tonumber(arg2)
		if spd==0 or spd<0 then
			ncMinimap.combatspeed = spd
			if InCombatLockdown() then
				for i=1,#objects do
					objects[i]:Hide()
				end
			end
			out("Moving objects in combat hidden")
		else
			ncMinimap.combatspeed = spd
			if InCombatLockdown() then
				for i=1,#objects do
					objects[i]:SetMovingSpeed(spd)
				end
			end
			out("Moving objects in combat speed set to "..spd)
		end
	elseif arg1=="lock" then
		if unlocked then
			unlocked = nil
			Minimap:RegisterForDrag("")
			out("Minimap locked")
		else
			unlocked = 1
			Minimap:RegisterForDrag("LeftButton")
			out("Minimap unlocked")
		end
	elseif arg1=="scale" then
		scale = tonumber(arg2)
		ncMinimap.scale = scale
		Minimap:SetScale(scale)
		for i=1,#objects do
			local n = objects[i]
			n:SetScale(scale)
		end
		out("Scale set to "..scale)
	elseif arg1=="color" then
		r, g, b = tonumber(arg2), tonumber(arg3), tonumber(arg4)
		ncMinimap.r, ncMinimap.g, ncMinimap.b = r, g, b
		p:SetBackdropBorderColor(r, g, b)
		for i=1,#objects do
			local n = objects[i]
			n:SetBackdropBorderColor(ncMinimap.r,ncMinimap.g,ncMinimap.b)			
		end
	else
		print("/ncm |cFFAA0000subcommand|r [|cFFFFFF00argument|r] - explanation (default value)\n|cFFAA0000lock|r - toggles minimap locking, when unlocked you can drag the minimap\n|cFFAA0000scale|r [|cFFFFFF00number|r] - scales the minimap (1)\n|cFFAA0000speed|r [|cFFFFFF00number|r] - sets the speed for the border when out of combat, set to 0 or negative to hide (20)\n|cFFAA0000combatspeed|r [|cFFFFFF00number|r] - sets the speed for the border when in combat, set to 0 or negative to hide (80)\n|cFFAA0000color|r [|cFFFFFF00r|r] [|cFFFFFF00g|r] [|cFFFFFF00b|r] - red green and blue can be values between 1(lightest) and 0(darkest) (0.6 0.6 0.6)")
	end
end

p:SetScript("OnEvent", function()
	p:SetScript("OnEvent", function() end)
	init()
end)
p:RegisterEvent("PLAYER_ENTERING_WORLD")